{
     "" Excel'.

  :  .

  .  2004.

}
unit Unit1;

{$IFDEF VER130} { Borland Delphi 5.x }
  {$DEFINE D5}
{$ENDIF}

{$IFDEF VER140} { Borland Delphi 6.x }
  {$DEFINE D6}
{$ENDIF}

{$IFDEF VER150} { Borland Delphi 7.x }
  {$DEFINE D7}
{$ENDIF}

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, {$IFNDEF D5} Variants,{$ENDIF} Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnDateTest: TButton;
    btnNumTest: TButton;
    btnInternational: TButton;
    btnColorFmt: TButton;
    btnFormula: TButton;
    btnVarArray: TButton;
    btnPageTitle: TButton;
    Button1: TButton;
    procedure btnDateTestClick(Sender: TObject);
    procedure btnNumTestClick(Sender: TObject);
    procedure btnInternationalClick(Sender: TObject);
    procedure btnColorFmtClick(Sender: TObject);
    procedure btnFormulaClick(Sender: TObject);
    procedure btnVarArrayClick(Sender: TObject);
    procedure btnPageTitleClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses OleServer, Excel2000, Office2000, Registry;

{$R *.dfm}

const
  lcid = LOCALE_USER_DEFAULT;

type
  {$IFDEF D7}
  TXLRange = ExcelRange;
  {$ELSE}
  TXLRange = Range;
  {$ENDIF}

function GetExcelVer: Single;
const
  xlKey = '\CLSID\%s\ProgID';
  xlKey2 = '\CLSID\%s\VersionIndependentProgID';
var
  R: TRegistry;
  S, XLApp: String;
  DS: Char;

begin
  DS := DecimalSeparator;
  DecimalSeparator := '.'; //   
  Result := 0;
  R := TRegistry.Create;
  try
    R.RootKey := HKEY_CLASSES_ROOT;
    if R.OpenKey(Format(xlKey2, [GUIDToString(CLASS_ExcelApplication)]), False) then begin
      XLApp := R.ReadString(EmptyStr); //    Excel.Application
      R.CloseKey;
    end;
    if R.OpenKey(Format(xlKey, [GUIDToString(CLASS_ExcelApplication)]), False) then begin
      S := R.ReadString(EmptyStr); //    Excel.Application.10 (XP)
      R.CloseKey;
      Result := StrToFloat(Copy(S, Length(XLApp) + 2, Length(S)));
    end;
  finally
    R.Free;
    DecimalSeparator := DS;
  end;
end;

{      }

{function XL_GetShortDateFormat(XLApp: ExcelApplication): String;
const
  sYear = '%s%0:s';
begin
  Result := XLApp.International[xlDayCode, lcid];
  if XLApp.International[xlDayLeadingZero, lcid]
    then Result := Result + XLApp.International[xlDayCode, lcid]; //  
  Result := Result + DateSeparator + XLApp.International[xlMonthCode, lcid];
  if XLApp.International[xlMonthLeadingZero, lcid]
    then Result := Result + XLApp.International[xlMonthCode, lcid];
  Result := Result + DateSeparator + Format(sYear,
    [XLApp.International[xlYearCode, lcid]]);
  if XLApp.International[xl4DigitYears, lcid]
    then Result := Result + Format(sYear, [XLApp.International[xlYearCode, lcid]]);
end;}

function XL_GetShortDateFormat(XLApp: ExcelApplication): String;
var d, m, y: Integer;
begin
  if XLApp.International[xlDayLeadingZero, lcid]
    then d := 2 else d := 1;
  if XLApp.International[xlMonthLeadingZero, lcid]
    then m := 2 else m := 1;
  if XLApp.International[xl4DigitYears, lcid]
    then y := 4 else y := 2;
  Result := Format('%1:s%0:s%2:s%0:s%3:s', [
    DateSeparator,
    StringOfChar(VarToStr(XLApp.International[xlDayCode, lcid])[1], d),
    StringOfChar(VarToStr(XLApp.International[xlMonthCode, lcid])[1], m),
    StringOfChar(VarToStr(XLApp.International[xlYearCode, lcid])[1], y)
  ]);
end;

function XL_GetNumberFormat(XLApp: ExcelApplication): String;
begin
  Result := Format('#%s##0%s%s', [
    XLApp.International[xlThousandsSeparator, lcid],
    XLApp.International[xlDecimalSeparator, lcid],
    StringOfChar('0', Integer(XLApp.International[xlCurrencyDigits, lcid]))
  ]);
end;

function XL_GetCurrencyFormat(XLApp: ExcelApplication): String;
begin
  Result := Format('%s "%s"', [
    XL_GetNumberFormat(XLApp),
    XLApp.International[xlCurrencyCode, lcid]
  ]);
end;

{ TForm1 }

procedure TForm1.btnDateTestClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
  R: TXLRange;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  try
    XL.ConnectKind := ckRunningOrNew; // -
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    R := ASheet.Range['A1', EmptyParam];
    R.Value2 := Date;
//    R.NumberFormat := 'd/mm/yy'; // 
    R.NumberFormat := '..'; // 
//    R.NumberFormatLocal := '..'; // 
//    R.NumberFormatLocal := 'd/mm/yy'; // 
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
  end;
end;

procedure TForm1.btnNumTestClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
  R: TXLRange;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  try
    XL.ConnectKind := ckRunningOrNew;
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    R := ASheet.Range['A1', EmptyParam];
    R.Value2 := 1234567.89;
//    R.NumberFormat := '#,##0.00'; //   ()
//    R.NumberFormat := '# ##0,00'; //   "" 
//    R.NumberFormatLocal := '# ##0,00'; //   "" 
    //    
    R.NumberFormat := XL_GetNumberFormat(XL.DefaultInterface);
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
  end;
end;

procedure TForm1.btnInternationalClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  try
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    ASheet.Range['A1:A2', EmptyParam].Value2 := 1234567.89;
    ASheet.Range['A1', EmptyParam].NumberFormat := XL_GetNumberFormat(XL.DefaultInterface);
    ASheet.Range['A2', EmptyParam].NumberFormat := XL_GetCurrencyFormat(XL.DefaultInterface);
    ASheet.Range['A3', EmptyParam].Value2 := Date;
    ASheet.Range['A3', EmptyParam].NumberFormat := XL_GetShortDateFormat(XL.DefaultInterface);
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
  end;
end;

procedure TForm1.btnColorFmtClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  try
    XL.ConnectKind := ckRunningOrNew;
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    ASheet.Range['A1', EmptyParam].Value := 1234567.89;
    ASheet.Range['A2', EmptyParam].Value := -1234567.89;
    ASheet.Range['A1:A2', EmptyParam].NumberFormat := Format('[]%s;[]-%0:s',
      [XL_GetNumberFormat(XL.DefaultInterface)]);;
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
  end;
end;

procedure TForm1.btnFormulaClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  try
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    ASheet.Range['A1:A2', EmptyParam].Value2 := 123.45;
    ASheet.Range['B1:B2', EmptyParam].Value2 := 6.07;
    ASheet.Range['C1', EmptyParam].Formula := '=round(A1*B1, 2)'; //    Excel'
    //     -     Windows
    //   Excel'
    ASheet.Range['C2', EmptyParam].FormulaLocal := Format('=(A2*B2%s 2)',
      [ListSeparator]);
    //   ""   Windows
//    ASheet.Range['C1', EmptyParam].FormulaLocal := '=(A1*B1; 2)';
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
  end;
end;

procedure TForm1.btnVarArrayClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
  MyVar: Variant;
  IsRusXL: Boolean;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  MyVar := VarArrayCreate([0, 2, 0, 2], varVariant); // 3 , 3 
  try
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    // ,     Excel
    IsRusXL := XL.LanguageSettings.LanguageID[msoLanguageIDUI] = $0419;

    //  
    MyVar[0, 0] := 10.72;
    MyVar[0, 1] := 3.05;
    if IsRusXL
      then MyVar[0, 2] := Format('=(RC[-1]*RC[-2]%s 2)', [ListSeparator])
      else MyVar[0, 2] := '=round(RC[-1]*RC[-2], 2)'; //  R1C1
    //  
    MyVar[1, 0] := 4.57;
    MyVar[1, 1] := 7.23;
    if IsRusXL
       then MyVar[1, 2] := Format('=(A2*B2%s 2)', [ListSeparator])
       else MyVar[1, 2] := '=round(A2*B2, 2)'; //  A1
    // 
    if IsRusXL
      then MyVar[2, 2] := '=(C1:C2)'
//      then MyVar[2, 2] := '=(R[-2]C:R[-1]C)' //  Formula  FormulaR1C1
      else MyVar[2, 2] := '=sum(C1:C2)';

    with ASheet.Range['A1:C3', EmptyParam] do begin
      Clear;
//      Formula := MyVar; // 
//      FormulaR1C1 := MyVar; //  ,      A1
//      FormulaR1C1Local := MyVar; //  ,      A1
//      FormulaLocal := MyVar; // 
//      Value := MyVar; // 
      Value2 := MyVar; // 
    end;
    
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
    VarClear(MyVar); 
  end;
end;

procedure TForm1.btnPageTitleClick(Sender: TObject);
var
  XL: TExcelApplication;
  WB: TExcelWorkbook;
  ASheet: TExcelWorksheet;
begin
  XL := TExcelApplication.Create(Self);
  WB := TExcelWorkbook.Create(Self);
  ASheet := TExcelWorksheet.Create(Self);
  try
    XL.Connect;
    WB.ConnectTo(XL.Workbooks.Add(EmptyParam, lcid));
//    WB.ConnectTo(XL.ActiveWorkbook);
    ASheet.ConnectTo(WB.ActiveSheet as _WorkSheet);
    XL.Visible[lcid] := True;
    if XL.LanguageSettings.LanguageID[msoLanguageIDUI] = $0419
      then ASheet.PageSetup.CenterFooter := //   
        '&"Arial"&8 &"Arial,"&' +
        '&"Arial,"  &"Arial,"&'
      else ASheet.PageSetup.CenterFooter := //   
        '&"Arial"&8 &"Arial,bold"&P' +
        '&"Arial,normal"  &"Arial,bold"&N';
    ASheet.Range['A1', EmptyParam].Value := 'Page titles test';
    ASheet.PrintPreview;
  finally
    ASheet.Free;
    WB.Free;
    XL.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  sXlMessage = '  %s  Excel %s'#10 +
    '(LanguageID User Interface 0x%0.4x)'#10#10 +
    'xlDecimalSeparator: %s'#10'xlThousandsSeparator: %s'#10 +
    'General format: %s';
  sXLVer: array[Boolean] of String = (' ', '');

var
  XL: TExcelApplication;
  
begin
  XL := TExcelApplication.Create(Self);
  try
    XL.Connect;
    Application.BringToFront;
    ShowMessageFmt(sXlMessage, [
      sXlVer[XL.LanguageSettings.LanguageID[msoLanguageIDUI] = $0419],
      XL.Version[lcid],
      XL.LanguageSettings.LanguageID[msoLanguageIDUI],
      XL.Application.International[xlDecimalSeparator, lcid],
      XL.Application.International[xlThousandsSeparator, lcid],
      XL.Application.International[xlGeneralFormatName, lcid]
    ]);
  finally
    XL.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {    Excel'  2k }
  if GetExcelVer < 9.0 then begin
    ShowMessage('     MS Excel 2000  !');
    Application.Terminate;
  end;
end;

end.
